import { javascriptLanguage, javascript } from '@codemirror/lang-javascript';
import { LRLanguage, LanguageSupport } from '@codemirror/language';
import { parseMixed } from '@lezer/common';
import { glimmerParser } from 'codemirror-lang-glimmer';
import { ExternalTokenizer, LRParser } from '@lezer/lr';
import { styleTags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const templateTagContent$1 = 8;

function matchForComment(commentEndPattern, commentToken, input) {
    for (let found = 0, i = 0;; i++) {
        if (input.next < 0) {
            if (i)
                input.acceptToken(commentToken);
            break;
        }
        let hasMatch = commentEndPattern[found] === input.next;
        if (!hasMatch) {
            found = 0;
            input.advance();
            break;
        }
        if (found === commentEndPattern.length - 1) {
            if (i > commentEndPattern.length - 1) {
                input.acceptToken(commentToken, 1 - commentEndPattern.length);
                break;
            }
            else {
                console.warn('Reached end of comment but there is still content left');
            }
            break;
        }
        found++;
        input.advance();
    }
}
const closingTemplateTag = '</template>'.split('').map((char) => char.charCodeAt(0));
const templateTagContent = new ExternalTokenizer((input) => {
    return matchForComment(closingTemplateTag, templateTagContent$1, input);
});

const templateTagHighlighting = styleTags({});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "!^QQOQOOOVORO'#C^OOOO'#Ca'#CaQQOQOOOOOP'#Cb'#CbO_ORO,58xOOOO,58x,58xOOOO-E6_-E6_OOOP-E6`-E6`OOOO1G.d1G.d",
  stateData: "g~ORPO~OSUOWSO~OSXOWSO~O",
  goto: "hVPPWPP[bTQORQRORVRQTPRWT",
  nodeNames: "⚠ Document GlimmerTemplateTag TemplateTag TemplateTag",
  maxTerm: 8,
  nodeProps: [
    ["closedBy", 3,"templateTagEnd"],
    ["openedBy", 4,"templateTagStart"]
  ],
  propSources: [templateTagHighlighting],
  skippedNodes: [0],
  repeatNodeCount: 2,
  tokenData: "#s~RP!^!_U~XQ!P!Q_#h#i!l~bP#h#ie~hP#X#Yk~nP#a#bq~tP#d#ew~zP#`#a}~!QP#T#U!T~!WP#h#i!Z~!^P#X#Y!a~!dP!`!a!g~!lOS~~!oP#X#Y!r~!uP#a#b!x~!{P#d#e#O~#RP#`#a#U~#XP#T#U#[~#_P#h#i#b~#eP#X#Y#h~#kP!`!a#n~#sOR~",
  tokenizers: [templateTagContent, 0],
  topRules: {"Document":[0,1]},
  tokenPrec: 0
});

function gjs() {
    return new LanguageSupport(gjsLanguage, [javascript().support]);
}
const gjsLanguage = LRLanguage.define({
    parser: parser.configure({
        wrap: parseMixed((node) => {
            if (node.type.name === 'Document')
                return null;
            if (node.type.name === 'GlimmerTemplateTag')
                return { parser: glimmerParser };
            return { parser: javascriptLanguage.parser };
        }),
    }),
});

export { gjs, gjsLanguage, parser as metaParser };
